﻿' At design time set:
'      ppdShapes.Document = pdocShapes

Public Class Form1
    Private Sub btnPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPreview.Click
        ' Display a print preview.
        ' Set the size.
        Dim frm As Form = DirectCast(ppdShapes, Form)
        If (chkMaximized.Checked) Then
            ' Display maximized.
            frm.WindowState = FormWindowState.Maximized
        Else
            ' Make the client area 400 x 400.
            frm.WindowState = FormWindowState.Normal
            frm.StartPosition = FormStartPosition.CenterScreen
            ppdShapes.ClientSize = New Size(400, 400)
        End If

        ' Set the dialog's title.
        frm.Text = "Numbers"

        ' Set the zoom level.
        If (chkZoom100.Checked) Then
            ' 100%.
            ppdShapes.PrintPreviewControl.Zoom = 1.0
        Else
            ' Auto.
            ppdShapes.PrintPreviewControl.AutoZoom = True
        End If

        ' Set anti-aliasing.
        ppdShapes.PrintPreviewControl.UseAntiAlias = chkAntiAlias.Checked

        ' Set other properties.
        ppdShapes.PrintPreviewControl.Columns = 3
        ppdShapes.PrintPreviewControl.Rows = 3
        ppdShapes.PrintPreviewControl.BackColor = Color.Orange ' Background color.
        ppdShapes.PrintPreviewControl.ForeColor = Color.Yellow ' Paper color.
        ppdShapes.PrintPreviewControl.StartPage = 3            ' Page 3 in the upper left.

        ' Display the dialog.
        ppdShapes.ShowDialog()
    End Sub

    ' Print the document's pages.
    Private m_NextPage As Integer = 0
    Private Sub pdocShapes_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles pdocShapes.PrintPage
        ' Draw the margins.
        Using dashed_pen As New Pen(Color.Red, 5)
            dashed_pen.DashPattern = New Single() {10, 10}
            e.Graphics.DrawRectangle(dashed_pen, e.MarginBounds)
        End Using

        ' Draw an ellipse.
        e.Graphics.DrawEllipse(Pens.Blue, e.MarginBounds)

        ' Draw the page number.
        ' Center it inside the margins.
        Dim sf As New StringFormat()
        sf.Alignment = StringAlignment.Center
        sf.LineAlignment = StringAlignment.Center

        Using the_font As New Font("Times New Roman", 200, FontStyle.Bold)
            Using the_brush As New SolidBrush(Color.Black)
                e.Graphics.DrawString(String.Format("{0}", m_NextPage + 1), _
                    the_font, the_brush, e.MarginBounds, sf)
            End Using
        End Using

        ' Next time print the next page.
        m_NextPage += 1

        ' We have more pages if wee have not yet printed page 10.
        e.HasMorePages = (m_NextPage <= 10)
    End Sub

    ' Get ready to print.
    Private Sub pdocShapes_BeginPrint(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintEventArgs) Handles pdocShapes.BeginPrint
        ' Start with page 0.
        m_NextPage = 0
    End Sub
End Class
